#!/bin/bash
#
# Description of the homework HW3B:
# This script should take in input the following arguments: 
# arg1: an URL to an SVN repository containing a dataset.
# arg2: a folder where to download the dataset
#
# Example usage of the script:
# 
#   ./checkdataset.sh http://svncourse.hep.lu.se/svncourse/trunk/somedataset destinationfolder   
#
# OBS: the URL and the folder are PARAMETERS. I will use different parameters
# than those above when testing your script.
# You should use the following arg1 to test your scripts:
#   http://svncourse.hep.lu.se/svncourse/trunk/floridop/Tutorial3b/data
#
# The script should read the dataset and do the requested numbered tasks below.
#
########################################################################


# 1. Check that all the parameters are present
# or give an error
if  [[ $# -le 1 ]];  then
    echo "Not enough arguments. Must be at least 2!";
    echo "Usage: $0 URL destinationfolder"
    exit 1
fi


# declare the variables to hold the parameters
SVNURL=$1
DESTDIR=$2

# 2. declare the variables to hold the parameters


# 3. run the svn command to retrieve the dataset (make sure svn is installed on the system!)
echo "Downloading files with svn..."
svn co $SVNURL $DESTDIR

# enter inside the destination dir
cd $DESTDIR

# 4. change dir into the destination dir

########################################################################
## now inspect the contents of the directory. Check what file is inside. Take note of
## the name of the file for the next task.
########################################################################

# 5. identify the type of file with the "file" command 
echo "The file type is:"
file nintendowiigamesprettyprinted.xml


########################################################################
## For the next task open the file found in the folder with geany and 
## inspect the dataset. 
## Identify information that might help you with the next step.
########################################################################

# 6. extract the lines containing the names of the videogames using grep and put them in a variable
echo "Extracting lines with grep..."
GREPLINES=$(grep GameTitle nintendowiigamesprettyprinted.xml)


# 7. write such list on a file called gamelist.txt
echo "writing lines to gamelist.txt..."
echo "$GREPLINES" > gamelist.txt


# 8. compress the file as gamelist.tar.gz
echo "compressing gamelist.txt..." 
tar zcf gamelist.tar.gz gamelist.txt


# 9. use a while loop and the 'read' command to scan each line of the gamelist.txt file.
# hint: search google for "Looping through the content of a file in Bash?"
# for each line count how many characters per line are there with the command wc.
# write the numbers in a file called linenumbers.txt
echo "counting character per line using a while loop..."
while IFS= read -r line; do
   echo "$line" | wc -c >> linenumbers.txt
done < gamelist.txt

